# log.nu -- 日志模块
#
# Copyright (C) 2022 KAAAsS

def level_color [level: int] {
    {
        0: "blue",
        10: "white",
        12: "white",
        15: "green",
        20: "yellow",
        25: "red",
    } | get ($level | into string)
}

export def main [
    level: int,
    s: string
] {
    let log_level = if ('KNOT_LOG_LEVEL' in $env) {
        $env.KNOT_LOG_LEVEL
    } else {
        10
    }
    if ($level >= $log_level) {
        let color = (level_color $level)
        print $"(ansi $color)($s)(ansi reset)"
    }
}

export def debug [s: string] {
    main 0 $s
}

export def info [s: string] {
    main 10 (
        # 非空则增加一个缩进
        if ($s | is-empty) { "" } else { $"- ($s)" }
    )
}

export def status [s: string] {
    main 12 $s
}

export def succ [s: string] {
    main 15 $s
}

export def warn [s: string] {
    main 20 $s
}

export def error [s: string] {
    main 25 $s
}
